<template>
  <div class="dialog-box" style="position: relative">
    <el-scrollbar class="custom-scroll content-box">
      <el-form
        ref="formEditVisaMetarialsListRef"
        :model="formData"
        :size="layoutStore.defaultFormItemSize"
        :rules="rules"
        label-width="120px"
        label-position="right"
        @submit.prevent
      >
        <el-row :gutter="16">
          <el-col :span="12">
            <el-form-item label="基础材料名字" prop="VisaMetarialsList.title">
              <el-input
                class="input-item"
                v-model="formData.VisaMetarialsList.title"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="基础材料介绍" prop="VisaMetarialsList.content">
              <el-input
                class="input-item"
                v-model="formData.VisaMetarialsList.content"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-scrollbar>
    <el-row class="footer-box" type="flex" justify="end" align="middle">
      <el-button :size="layoutStore.defaultFormItemSize" @click="onCancel()">取消</el-button>
      <el-button :size="layoutStore.defaultFormItemSize" type="primary" @click="onSubmitVisaMetarialsListClick()">保存</el-button>
    </el-row>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formEditVisaMetarialsList',
};
</script>

<script setup lang="ts">
import { DialogProp } from '@/components/Dialog/types';
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { VisaMetarialsListData } from '@/api/generated/visaMetarialsListController';
import { VisaMetarialsListController } from '@/api/generated';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const {
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
    id?: ANY_OBJECT;
    visaId?: ANY_OBJECT;
    saveOnSubmit?: boolean;
    rowData?: ANY_OBJECT;
    // 当使用Dialog.show弹出组件时，须定义该prop属性，以便对dialog进行回调
    dialog?: DialogProp<ANY_OBJECT[]>;
  }>(),
  {
    subPage: 0,
    id: undefined,
    visaId: undefined,
    saveOnSubmit: true,
    rowData: undefined,
    dialog: undefined,
  },
);

const formEditVisaMetarialsListRef = ref();
// 表单数据定义
type FormEditVisaMetarialsListData = {
  VisaMetarialsList: VisaMetarialsListData;
};
// 表单数据
const formData = reactive<FormEditVisaMetarialsListData>({
  VisaMetarialsList: {
    // 基础材料id
    id: undefined,
    // 签证商品id
    visaId: undefined,
    // 基础材料名字
    title: undefined,
    // 基础材料介绍
    content: undefined,
    // 是否逻辑删除
    deleteFlag: undefined,
    // 创建时间
    createTime: undefined,
    // 创建人id
    createUserId: undefined,
    // 更新时间
    updateTime: undefined,
    // 更新人id
    updateUserId: undefined,
  },
},
);
// 表单验证规则
const rules = reactive({
  'VisaMetarialsList.content': [
  ],
  'VisaMetarialsList.title': [
    {required: true, message: '请输入基础材料名字', trigger: 'blur'}
  ],
});

const onCancel = () => {
  if (props.dialog) {
    props.dialog.cancel();
  }
};

const isEdit = computed(() => {
  return props.saveOnSubmit ? props.id != null : props.rowData != null;
});

// 初始化页面数据
const loadVisaMetarialsListData = () => {
  return new Promise<void>((resolve, reject) => {
    if (!isEdit.value) {
      resolve();
      return;
    }
    if (!props.saveOnSubmit && props.rowData != null) {
      formData.VisaMetarialsList = JSON.parse(JSON.stringify(props.rowData));
      resolve();
      return;
    }
    let params: ANY_OBJECT = {
      id: props.id
    };
    VisaMetarialsListController.view(params).then(res => {
      formData.VisaMetarialsList = { ...res.data };
      resolve();
    }).catch(e => {
      reject(e);
    });
  });
};
const onUploadError = () => {
  ElMessage.error('文件上传失败');
};
const onUploadLimit = () => {
  ElMessage.error('已经超出最大上传个数限制');
};
const refreshFormEditVisaMetarialsList = () => {
  // 刷新段落
};
/**
 * 重置过滤值
 */
const resetFormEditVisaMetarialsList = () => {
  refreshFormEditVisaMetarialsList();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormEditVisaMetarialsList();
};
/**
 * 保存
 */
const onSubmitVisaMetarialsListClick = () => {
  formEditVisaMetarialsListRef.value.validate((valid) => {
    if (!valid) return;
    // 级联操作
    if (!props.saveOnSubmit) {
      let retFormData = {
        ...formData.VisaMetarialsList
      };
  props.dialog?.submit(retFormData);
      return;
    }
    let params: ANY_OBJECT = {
      visaMetarialsListDto: {
        id: formData.VisaMetarialsList.id,
        visaId: formData.VisaMetarialsList.visaId,
        title: formData.VisaMetarialsList.title,
        content: formData.VisaMetarialsList.content,
        createTime: formData.VisaMetarialsList.createTime,
        createUserId: formData.VisaMetarialsList.createUserId,
        updateTime: formData.VisaMetarialsList.updateTime,
        updateUserId: formData.VisaMetarialsList.updateUserId,
      }
    };

    let httpCall = isEdit.value ? VisaMetarialsListController.update : VisaMetarialsListController.add;
    httpCall(params).then(res => {
      ElMessage.success('保存成功');
      props.dialog?.submit();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  });
};
const formInit = () => {
  loadVisaMetarialsListData().then(res => {
    if (isEdit.value) refreshFormEditVisaMetarialsList();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};

onMounted(() => {
  formInit();
  formData.VisaMetarialsList.visaId = props.visaId;
});
</script>
